/*###################################################################################

USE AT OWN RISK!!!

Object Floor Layer Switcheroo
------------------------------------
	By Morn Erasmus
	version 0.1
	Date Created: 09 May 2020
	Last Modified: 09 May 2020
	
USE AT OWN RISK!!!	

###################################################################################*/

(
	renderSceneDialog.close()
	rendTimeType = 1
	rendSaveFile=false
	rc=renderers.current
	rc.output_splitgbuffer=true	
	mySaveFolder = ((getdir #renderoutput) + "\\layers_objects_floors")
	makedir mySaveFolder
	
	--loop through each frame and render
	for t = 0 to 280 do
	(
		sliderTime = t
		
		--at frame 0, switch off all object and floor layers except start conditions
		if (t == 0) then
		(	
			for i = 0 to layerManager.count-1 do
			(
				local ilayer = layerManager.getLayer i
				local lname = ilayer.name
				
				if ((toUpper lname) == (toUpper "Object01")) then ilayer.on = true
				if ((toUpper lname) == (toUpper "Floor01")) then ilayer.on = true

				if ((toUpper lname) == (toUpper "Object02") or (toUpper lname) == (toUpper "Object03") or (toUpper lname) == (toUpper "Object04")) then ilayer.on = false
				if ((toUpper lname) == (toUpper "Floor02") or (toUpper lname) == (toUpper "Floor03") or (toUpper lname) == (toUpper "Floor04") or (toUpper lname) == (toUpper "Floor05") or (toUpper lname) == (toUpper "Floor06") or (toUpper lname) == (toUpper "Floor07")) then ilayer.on = false
			)
		)	

		------------------------------------------------------------------------------------
		--------------------------------------objects--------------------------------------
		------------------------------------------------------------------------------------
		
		-- switch to object 02 at frame 70
		if (t == 70) then
		(	
			for i = 0 to layerManager.count-1 do
			(
				local ilayer = layerManager.getLayer i
				local lname = ilayer.name

				if ((toUpper lname) == (toUpper "Object01")) then ilayer.on = false
				if ((toUpper lname) == (toUpper "Object02")) then ilayer.on = true
			)
		)	

		-- switch to object 03 at frame 140
		if (t == 140) then
		(	
			for i = 0 to layerManager.count-1 do
			(
				local ilayer = layerManager.getLayer i
				local lname = ilayer.name

				if ((toUpper lname) == (toUpper "Object02")) then ilayer.on = false
				if ((toUpper lname) == (toUpper "Object03")) then ilayer.on = true
			)
		)

		-- switch to object 04 at frame 210
		if (t == 210) then
		(	
			for i = 0 to layerManager.count-1 do
			(
				local ilayer = layerManager.getLayer i
				local lname = ilayer.name

				if ((toUpper lname) == (toUpper "Object03")) then ilayer.on = false
				if ((toUpper lname) == (toUpper "Object04")) then ilayer.on = true
			)
		)			

		------------------------------------------------------------------------------------
		--------------------------------------floors--------------------------------------
		------------------------------------------------------------------------------------
		
		-- switch to floor 02 at frame 40
		if (t == 40) then
		(	
			for i = 0 to layerManager.count-1 do
			(
				local ilayer = layerManager.getLayer i
				local lname = ilayer.name

				if ((toUpper lname) == (toUpper "Floor01")) then ilayer.on = false
				if ((toUpper lname) == (toUpper "Floor02")) then ilayer.on = true
			)
		)	

		-- switch to floor 03 at frame 80
		if (t == 80) then
		(	
			for i = 0 to layerManager.count-1 do
			(
				local ilayer = layerManager.getLayer i
				local lname = ilayer.name

				if ((toUpper lname) == (toUpper "Floor02")) then ilayer.on = false
				if ((toUpper lname) == (toUpper "Floor03")) then ilayer.on = true
			)
		)

		-- switch to floor 04 at frame 120
		if (t == 120) then
		(	
			for i = 0 to layerManager.count-1 do
			(
				local ilayer = layerManager.getLayer i
				local lname = ilayer.name

				if ((toUpper lname) == (toUpper "Floor03")) then ilayer.on = false
				if ((toUpper lname) == (toUpper "Floor04")) then ilayer.on = true
			)
		)	

		-- switch to floor 05 at frame 160
		if (t == 160) then
		(	
			for i = 0 to layerManager.count-1 do
			(
				local ilayer = layerManager.getLayer i
				local lname = ilayer.name

				if ((toUpper lname) == (toUpper "Floor04")) then ilayer.on = false
				if ((toUpper lname) == (toUpper "Floor05")) then ilayer.on = true
			)
		)

		-- switch to floor 06 at frame 200
		if (t == 200) then
		(	
			for i = 0 to layerManager.count-1 do
			(
				local ilayer = layerManager.getLayer i
				local lname = ilayer.name

				if ((toUpper lname) == (toUpper "Floor05")) then ilayer.on = false
				if ((toUpper lname) == (toUpper "Floor06")) then ilayer.on = true
			)
		)	

		-- switch to floor 07 at frame 240
		if (t == 240) then
		(	
			for i = 0 to layerManager.count-1 do
			(
				local ilayer = layerManager.getLayer i
				local lname = ilayer.name

				if ((toUpper lname) == (toUpper "Floor06")) then ilayer.on = false
				if ((toUpper lname) == (toUpper "Floor07")) then ilayer.on = true
			)
		)			
		
		-- save output and render
		rc.output_splitfilename=(mySaveFolder + "\\test0000.png")
		tmpbm = Bitmap 10 10 fileName:rc.output_splitfilename
		save tmpbm
		rc.output_splitbitmap = tmpbm
			
		max quick render			
	)
	
	--some cleanup
	rc.output_splitfilename=""
	rc.output_splitgbuffer=false
	sliderTime=0
)
